<script>
    import { createEventDispatcher } from "svelte";
    import { ComboBox } from "carbon-components-svelte";
    import Select from "svelte-select";

    const dispatch = createEventDispatcher();
    function addRow() {
        newRow.id = newRowId++;
        if (newRow.responsible == 2) {
            newRow.responsible = Math.floor(Math.random() * 2);
        }
        if (newRow.everyNWeeksManual!= null){
            newRow.everyNWeeks=newRow.everyNWeeksManual;
        }
        if(newRow.durationManual!=null){
            newRow.duration = newRow.durationManual;
        }
        tasks = [...tasks, newRow];
        resetNewRow();
    }

    function resetNewRow() {
        newRow = {
            name: "",
            duration: 60,
            durationManual: null,
            everyNWeeks: 1,
            everyNWeeksManual: null,
            responsible: 2,
            id: null,
        };
    }

    function deleteTask(taskToDelete) {
        tasks = tasks.filter((task) => task.id != taskToDelete.id);
        console.log(tasks);
    }

    function editTask(taskToEdit) {
        console.log(taskToEdit);
        taskToEdit.isEditing = true;
        tasks = tasks.map(function (task) {
            if (task.id != taskToEdit.id) {
                return { ...task };
            }
            task.isEditing = true;
            return { ...task };
        });
    }

    function finishEditing(taskToEdit) {
        taskToEdit.isEditing = false;
        tasks = tasks.map(function (task) {
            if (task.id != taskToEdit.id) {
                return { ...task };
            }
            task.isEditing = false;
            return { ...task };
        });
    }

    function isDisabled(task, tasks) {
        if (task.name == "") {
            return true;
        }
        for (let compteur = 0; compteur < tasks.length; compteur++) {
            if (tasks[compteur].name == task.name) {
                return true;
            }
        }
        return false;
    }

    let users = {
        0: { username: "Max", email: "max@mail.com" },
        1: { username: "Tang", email: "tang@mail.vom" },
        2: { username: "Au hasard", email: null },
    };
    let tasks = [
        { name: "Frigo", duration: 50, everyNWeeks: 1, responsible: 0, id: 0 },
    ];
    let newRow = {
        name: "Aspi",
        duration: 60,
        durationManual: null,
        everyNWeeks: 1,
        everyNWeeksManual: null,
        responsible: 2,
        id: 1,
    };

    let newRowId = 1;

    let possibleDurations = [15, 30, 45, 60, 120, 300, "manual"];
    let possibleNWeeks = [1, 2, 3, 4, 8, 12, 24, "manual"];
    let responsibles = [0, 1, 2];
</script>

<div
    class=" is-fullwidth has-background-new-tertiary"
    style="height: 100px; z-index: 1000;"
>
    <nav
        class="navbar   is-fixed-top is-max-desktop has-background-new-tertiary"
        style="width: 100%; margin: auto; height: 100px; "
    >
        <div
            class="container has-background-new-tertiary"
            style="max-width: 1230px;"
        >
            <div class="navbar-brand ">
                <a href="#first-section" class="navbar-item ml-2">
                    <img
                        src="Images/iconMenage.png"
                        alt="LogoTitre"
                        style="min-height: 4.25rem;"
                    />
                </a>

                <!-- svelte-ignore a11y-missing-attribute -->
                <a
                    role="button"
                    class="navbar-burger is-hoverable"
                    aria-label="menu"
                    aria-expanded="false"
                    data-target="navbar"
                >
                    <span aria-hidden="true" />
                    <span aria-hidden="true" />
                    <span aria-hidden="true" />
                </a>
            </div>

            <div id="navbar" class="navbar-menu">
                <div
                    class="navbar-end has-text-weight-bold"
                    style="color: #FAAD80 !important;"
                >
                    <div style="margin: auto;">
                        <a
                            href="#taches"
                            class="navbar-item is-tab"
                            style="color: #FAAD80 !important;"
                        >
                            Vos tâches
                        </a>
                    </div>
                    <div style="margin: auto;">
                        <a
                            href="#partage"
                            class="navbar-item is-tab "
                            style="color: #FAAD80 !important;"
                        >
                            Votre partage
                        </a>
                    </div>

                    <div style="margin: auto;">
                        <a
                            href="#calendrier"
                            class="navbar-item is-tab"
                            style="color: #FAAD80 !important;"
                        >
                            Votre calendrier
                        </a>
                    </div>

                    <div style="margin: auto;">
                        <a
                            href="#compte"
                            class="navbar-item is-tab"
                            style="color: #FAAD80 !important;"
                        >
                            Votre compte
                        </a>
                    </div>
                </div>
            </div>
        </div>
    </nav>
</div>

<div class="has-background-new-secondary">
    <div class="container " style="max-width: 1230px;">
        <div id="taches" class="py-6">
            <h1
                class="box title is-2 has-text-centered has-background-new-primary pt-5"
                style="max-width: 300px; margin: auto;"
            >
                Vos tâches
            </h1>
            <div class="container pt-5" style="max-width: 700px;">
                <h1 class="subtitle is-5 pt-3 px-4">
                    Définissez les différentes tâches que vous souhaitez
                    partager ainsi que leur durée et leur fréquence. Pour la
                    durée, rentrez uniquement le nombre d'heures que nécessite
                    la tâche en question et pour la fréquence, rentrez le nombre
                    de fois que cette tâche doit être effectuée par semaine (ex
                    : 0.5 si elle doit être faite une semaine sur deux).
                </h1>
            </div>
        </div>

        <table
            class="table is-striped pt-5 has-background-new-primary"
            id="taksTable"
            style="min-width: 70%; margin: auto;"
        >
            <thead>
                <tr>
                    <th>Tâche</th>
                    <th>Durée</th>
                    <th>Fréquence</th>
                    <th>Responsable</th>
                </tr>
            </thead>
            <tbody>
                {#each tasks as task}
                    <tr>
                        {#if task.isEditing || task.id==null}
                            {#if task.id==null}
                                <tr>
                                    <td>geelfe</td>
                                </tr>
                            {/if}
                            <td> <input bind:value={task.name} /> </td>
                            <td>
                                <select
                                    bind:value={task.duration}
                                    style="width: 100%;"
                                >
                                    {#each possibleDurations as possibleDuration}
                                        <option value={possibleDuration}>
                                            {#if possibleDuration < 60}
                                                {possibleDuration} minutes
                                            {:else if possibleDuration < 120}
                                                {possibleDuration / 60} heure
                                            {:else if possibleDuration < 9999}
                                                {possibleDuration / 60} heures
                                            {:else}
                                                {possibleDuration}
                                            {/if}
                                        </option>
                                    {/each}
                                </select>
                            </td>
                            <td>
                                <select 
                                    bind:value={task.everyNWeeks}
                                    style="width: 100%;"
                                >
                                    {#each possibleNWeeks as possibleNWeek}
                                        <option value={possibleNWeek}>
                                            {#if task.everyNWeeks == 1}
                                                Chaque semaine
                                            {:else if task.everyNWeeks < 4}
                                                Toutes les {task.everyNWeeks} semaines
                                            {:else if task.everyNWeeks == 4}
                                                Tous les mois
                                            {:else if task.everyNWeeks < 999}
                                                Tous les {task.everyNWeeks / 4} mois
                                            {:else}
                                                {task.everyNWeeks}
                                            {/if}
                                        </option>
                                    {/each}
                                </select>
                                {#if task.everyNWeeks == "manual"}
                                    <p>Durée en minutes</p>
                                    <input bind:value={task.everyNWeeks} />
                                {/if}
                            </td>
                            <td>
                                <select
                                    bind:value={task.responsible}
                                    style="width: 100%;"
                                >
                                    {#each responsibles as responsible}
                                        <option value={responsible}>
                                            {#if users[responsible].username==2}
                                                {users[responsible].username} = {Math.floor(Math.random() * 2)}

                                            {/if} 
                                            {users[responsible].username}
                                        </option>
                                    {/each}
                                </select>
                                {#if task.responsible==2}
                                  <div hidden>  {task.responsible = Math.floor(Math.random() * 2)} </div>

                                            {/if} </td
                            >
                            <button on:click={finishEditing(task)}
                                >Fini d'edit</button
                            >
                        {:else}         

                        <!-- Dans ce cas là on affiche juste les taches alors que dans le premier if on bind une tache -->
                           
                            <td>{task.name}</td>
                            <td>
                                {#if task.duration < 60}
                                    {task.duration} minutes
                                {:else if task.duration < 120}
                                    {task.duration / 60} heure
                                {:else if task.duration < 9999}
                                    {task.duration / 60} heures
                                {:else}
                                    {task.duration}
                                {/if}
                            </td>
                            <td
                                >{#if task.everyNWeeks == 1}
                                    Chaque semaine
                                {:else}
                                    {#if task.everyNWeeks < 4}
                                        Toutes les {task.everyNWeeks} semaines
                                    {:else if task.everyNWeeks == 4}
                                        Tous les mois
                                    {:else if task.everyNWeeks < 999}
                                        Tous les {task.everyNWeeks / 4} mois
                                    {:else}
                                        {task.everyNWeeks}
                                    {/if}
                                {/if}</td
                            >
                            <td>{users[task.responsible].username}</td>
                            <button on:click={deleteTask(task)}>
                                Supp tâche</button
                            >
                            <button on:click={editTask(task)}>
                                Edit tâche</button
                            >
                        {/if}
                {/each}
                <tr>
                    <td> <input bind:value={newRow.name} /> </td>
                    <td>
                        <select
                            bind:value={newRow.duration}
                            style="width: 100%;"
                        >
                            {#each possibleDurations as possibleDuration}
                                <option value={possibleDuration}>
                                    {#if possibleDuration < 60}
                                        {possibleDuration} minutes
                                    {:else if possibleDuration < 120}
                                        {possibleDuration / 60} heure
                                    {:else if possibleDuration < 9999}
                                        {possibleDuration / 60} heures
                                    {:else}
                                        {possibleDuration}
                                    {/if}
                                </option>
                            {/each}
                        </select>
                        {#if newRow.duration === "manual"}
                            <p> Durée en minutes</p>
                            <input bind:value={newRow.durationManual}/>
                        {/if}
                    </td>
                    

                    <td>
                        <select
                            bind:value={newRow.everyNWeeks}
                            style="width: 100%;"
                        >
                            {#each possibleNWeeks as possibleNWeek}
                                <option value={possibleNWeek}>
                                    {#if possibleNWeek < 4}
                                        Toutes les {possibleNWeek} semaines
                                    {:else if possibleNWeek == 4}
                                        Tous les mois
                                    {:else if possibleNWeek <= 999}
                                        Tous les {possibleNWeek / 4} mois
                                    {:else}
                                        {possibleNWeek}
                                    {/if}
                                </option>
                            {/each}
                        </select>
                        {#if newRow.everyNWeeks == "manual"}
                            <p>Durée en semaines</p>
                            <input bind:value={newRow.everyNWeeksManual} />
                        {/if}
                    </td>
                    <td>
                        <select
                            bind:value={newRow.responsible}
                            style="width: 100%;"
                        >
                            {#each responsibles as responsible}
                                <option value={responsible}>
                                    {users[responsible].username}
                                </option>
                            {/each}
                        </select></td
                    >
                    <button
                        disabled={isDisabled(newRow, tasks)}
                        on:click={addRow(newRow)}>Ajouter cette tâche</button
                    >
                </tr>
            </tbody>
        </table>
    </div>
</div>

<button
    on:click={() => dispatch("changePage", "calendar")}
    class="button is-large is-info">Calendrier</button
>
